<template>
	<section>
		<h1 class="title is-1">Vota</h1>
		<h2 class="subtitle">Dettagli contratto di Voto</h2>
		<p>Indirizzo contratto: {{$route.query.contract_address}}</p>
		<p>Data e ora di inizio: {{this.dateTimeStart}}</p>
		<p>Data e ora di fine: {{this.dateTimeEnd}}</p>

		<h3 class="title is-3">Quesito</h3>
		<h4 class="title is-4">{{this.question}}</h4>

		<p>Opzioni votabili:</p>

		<ul>
			<li v-for="option in this.optionList"><b-radio 
				v-model="selectedOption"
        	    :native-value="option"
        	>
        	       	{{option.optionText}}
			</b-radio></li>
		</ul>

		<p>Stai votando: <strong>{{selectedOption.optionText}}</strong><strong v-if="selectedOption.optionText == null ">Nessuna opzione selezionata</strong></p>

        <p v-if="this.isElectionNotStarted">Votazione non ancora aperta, non puoi votare</p>
        <p v-if="this.isElectionFinished">Votazione chiusa, non puoi votare</p>
        <b-button @click="castVote()" :disabled="this.isElectionFinished || this.isElectionNotStarted">Vota</b-button>

        <section v-if="this.hasVoted">
			<p>Hai votato!</p>
        	<br>
        	<b-button 
        		type="is-info"
        		tag="a"
                :href="'https://ropsten.etherscan.io/tx/' + this.transactionHash"
                target="_blank"
        	>
        		Guarda su Etherscan
        	</b-button>        	
        </section>

		<stack-modal
    		:show="show"
    	    title="Dummy auth with Smart Card"
    	    @close="show=false"
    	    :modal-class="{ ['modal-xl']: true }"
    	    :save-button="{
    	    	visible: false
    	    }"
    	>
    		<div class="container">
    			<b-button type="is-success" @click="completeAuth()">Completa l'autenticazione</b-button>
    			<b-button type="is-danger" @click="authenticationError()">Fallisci l'autenticazione</b-button>
			</div>
    	</stack-modal>
	</section>
</template>

<script>
	import { ethers } from 'ethers'
	import Contract from '../static/contracts/Voting.json'
	import StackModal from '@innologica/vue-stackable-modal'

	export default {
		layout: 'none',

		components: {
			StackModal,
		},

		async mounted() {
			this.loadingComponent = this.$buefy.loading.open()
			const provider = new ethers.providers.Web3Provider(window.web3.currentProvider)
      		await ethereum.enable()
      		const signer = provider.getSigner()

			this.contractAddress = this.$route.query.contract_address
			this.VotingContract = new ethers.Contract(this.contractAddress, Contract.abi, signer)

			this.question = await this.VotingContract.getQuestion()

			this.startTimestamp = await this.VotingContract.voteStartTimestamp()
			this.endTimestamp = await this.VotingContract.voteEndTimestamp()

			this.dateTimeStart = new Date(this.startTimestamp.toNumber()*1000)
			this.dateTimeEnd = new Date(this.endTimestamp.toNumber()*1000)

			const totalOptions = await this.VotingContract.ballotScheme()
			for (let i = 0; i < totalOptions.totalOptionsVoting; i++) {
				const optionText = await this.VotingContract.getOption(i)
				const option = {
					optionId: i,
					optionText: optionText
				}
				this.optionList.push(option)
			}

			const currentTimestamp = Math.round(Date.now() / 1000)
			if (currentTimestamp > this.endTimestamp) {
				this.isElectionFinished = true	
			}

			if (currentTimestamp < this.startTimestamp) {
				this.isElectionNotStarted = true
			}

			this.loadingComponent.close()
		},

		methods: {
			castVote: function() {
				this.show = true
			},
			completeAuth: async function () {
				this.show = false
				this.loadingComponent = this.$buefy.loading.open()
				const optionId = this.selectedOption.optionId
				alert(optionId.toString())
				const castVoteMethodCall = await this.VotingContract.castVote(optionId.toString(), 'dummySignature')
				this.transactionHash = castVoteMethodCall.hash
				await castVoteMethodCall.wait()
				
				this.hasVoted = true
				this.loadingComponent.close() 
			},
			authenticationError() {
				this.show = false
                const notif = this.$buefy.notification.open({
                    duration: 5000,
                    message: `Autenticazione fallita!`,
                    position: 'is-bottom-right',
                    type: 'is-danger',
                    hasIcon: true
            	})
            },
		},

		data() {
			return {
				hasVoted: false,
				transactionHash: '',
				isElectionNotStarted: false,
				isElectionFinished: false,
				selectedOption: '',
				VotingContract: null,
				startTimestamp: 0,
				endTimestamp: 0,
				loadingComponent: null,
				contractAddress: '',
				show: false,
				question: '',
				dateTimeStart: '',
				dateTimeEnd: '',
				optionList: [],
			}
		}
	}
</script>

<style>
    @import "https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css";
</style>

<style lang="scss">
    @import "../node_modules/@innologica/vue-stackable-modal/src/assets/transitions/translate-fade.scss";
    @import "../assets/scss/modal.scss";
</style>